;*********************************************************
;**    67 Hz fr Standard-VGA im  640x480 Grafikmodus   **
;**   bersetzen mit TASM oder MASM in eine COM-Datei   **
;**              27.10.91  -mat                         **
;*********************************************************

code    segment public
        assume  cs:code,ds:code
        org     0100h
;----------------
w       equ     word ptr

dos     macro   func,parm       ;; DOS call
        ifnb    <parm>
         mov    ax,func*256+parm
        else
         mov    ah,func
        endif
        int     21h
endm
;----------------
start:  jmp     install
        db      8,8
titl:   db      '*** 67 Hertz ***$',8,32,26

new10   proc    near
        cmp     ah,0            ; Moduswechsel ?
        jnz     sk1             ; nein
        mov     cs:saveax,ax    ; ja, neuen Modus speichern
sk1:    pushf                   ; alte INT-Routine rufen
;       call    dword ptr cs:save10
        db      9ah             ; opcode call far
save10  dd      0               ; alter Vektor
        push    ax              ; Register retten
        push    dx
        mov     ax,cs:saveax
        cmp     ax,12h          ; Modus 12?
        jz      doit            ; nein, ein anderer
        cmp     ax,2eh          ; Modus 2e? (640x480X256)
        jz      doit            ; nein, ein anderer

; fr den Standard-Textmodus werden 480 Zeilen gesetzt
; --> dadurch kleineres Bild.
        cmp     ax,3h           ; Modus 3?
        jnz     skip            ; nein, ein anderer

;*******************************
; jetzt kommt's !!
doit:   mov     dx,03cch        ; Misc Out Register
        in      al,dx           ; lesen
        and     al,0f3h         ; Clock-Bits lschen
        or      al,0c4h         ; 28 MHz einschalten
        mov     dx,3c2h         ; Misc Out schreiben
        out     dx,al
;*******************************
        mov     cs:saveax,-1    ; Flag ungltig machen
skip:   pop     dx              ; Register zurckladen
        pop     ax
        iret                    ; Ende des Interrupts

saveax  dw      -1      ; -1 heit ungltig
                        ; 0  heit aktiver Moduswechsel
new10   endp

;* Installationsteil
install:
        lea     dx,titl         ; Titel drucken
        dos     9

        dos     35h,10h         ; alten Vektor lesen
        mov     w save10,bx     ; und abspeichern
        mov     w save10+2,es

        lea     dx,new10        ; Vektor setzen
        dos     25h,10h

; die verringerte Bildgre gleich neu setzen

        mov     ah,0fh          ; Videomode auslesen
        int     10h
        mov     ah,0h           ; .. und wieder setzen
        int     10h

        lea     dx,install
        int     27h             ; soviel resident machen

code    ends
        end     start